using namespace std;
#include <time.h>

#define long_proc typedef long (__stdcall *zProc)
#define long_proc_c typedef long (__cdecl *zProc)
#define void_proc_c typedef void (__cdecl *zProc)
#define LOINT(a) ((SHORT)(a))
#define HIINT(a) ((SHORT)(((DWORD)(a) >> 16) & 0xFFFF))
//#define LOWORD(a) ((WORD)(a))
//#define HIWORD(a) ((WORD)(((DWORD)(a) >> 16) & 0xFFFF))
#define MAKLNG(a, b) ((LONG) (((WORD) (a)) | ((DWORD) ((WORD) (b))) << 16))
#define UBOUND(T) ((long) T.size())
#define strSize(s) ( sizeof(s) / sizeof(s[0]) ) 

static wchar_t *$NULL = L"";
const wchar_t *$SPACE = L" ";
const wchar_t *$DOT = L".";
const wchar_t *$ANTI = L"\\";
const wchar_t *$ZLIM = L"|";

long zTrace(IN WCHAR* sPtr) {
    long nRet = 0;
    static HMODULE hDll;
    if (hDll == 0) {
        if (sizeof(LONG_PTR) == 8) {
            hDll = LoadLibrary(L"zTrace64");
        }
        else {
            hDll = LoadLibrary(L"zTrace32");
        }
    }
    if (hDll) {
        long_proc(WCHAR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc)GetProcAddress(hDll, "zTrace"); }
        if (hProc) { nRet = hProc(sPtr); }
    }
    return nRet;
}

long CheckStyle(IN long nMainStyle, IN long nStyleToCheck) {
    long nRet = 0;
    if ((nMainStyle & nStyleToCheck) == nStyleToCheck) { nRet = -1; }
    return nRet;
}

WCHAR* STRL(IN long N) {
    static WCHAR longstr[33] = {0};
    _ltow_s(N, longstr, 10);
    return (WCHAR*)longstr;
}

WCHAR* STRH(IN long N) {
    static WCHAR hexstr[33] = { 0 };
    swprintf_s(hexstr, strSize(hexstr), L"0x%.8X", N);
    return hexstr;
}

WCHAR* STRF(IN float N) {
    static WCHAR ws[33] = {0};
    swprintf_s(ws, strSize(ws), L"%f", N);
    return (WCHAR*) ws;
}

long Width(IN RECT &r){
    return r.right - r.left;
}

long Height(IN RECT &r) {
    return r.bottom - r.top;
}

long CheckWindowStyle(IN HWND hWnd, IN long nStyle) {
    long nRet = 0;
    if ((GetWindowLongPtr(hWnd, GWL_STYLE) & nStyle) == nStyle) { nRet = -1; }
    return nRet;
}

void ClearMemory(IN void* mem, IN long nSize) {
    memset(mem, 0, nSize);
}

WCHAR* Path_Combine(OUT WCHAR* zResource, IN WCHAR* path, IN WCHAR* combine) {
    // This version try to protect from buffer overflow
    long nLenPath = lstrlen(path), nLenCombine = lstrlen(combine);
    ClearMemory(zResource, MAX_PATH * sizeof(WCHAR));
    if (nLenPath < MAX_PATH) {
        MoveMemory(zResource, path, nLenPath * sizeof(WCHAR));
        if (nLenPath + nLenCombine < MAX_PATH) {
            MoveMemory(&zResource[nLenPath], &combine[0], nLenCombine * sizeof(WCHAR));
        }
    }
    return zResource;
}

// Warning malloc is being used, don't forget to use free!
char* replaceA(IN const char* s, IN const char* oldW, IN const char* newW) {
    char* result;
    long K = 0, cnt = 0, newlen = lstrlenA(newW), oldlen = lstrlenA(oldW);
 
    // Counting the number of times old word occur in the string
    for (K = 0; s[K] != L'\0'; K++) {
        if (strstr(&s[K], oldW) == &s[K]) {
            cnt++;
            // Jumping to index after the old word.
            K += oldlen - 1;
        }
    }
 
    // Making new string of enough length
    long nLen = (K + cnt * (newlen - oldlen) + 1);// * 2; we are using char here rather than WCHAR
    result = (char*) malloc(nLen);
 
    K = 0;
    while (*s) {
        // compare the substring with the result
        if (strstr(s, oldW) == s) {
            strcpy(&result[K], newW);
            K += newlen;
            s += oldlen;
        } else {
            result[K++] = *s++;
        }
    }
    result[K] = '\0';
    return result;
}

char* Path_CombineA(OUT char* zResource, IN char* path, IN char* combine) {
    long offset = lstrlenA(path);
    ClearMemory(zResource, MAX_PATH);
    if (strstr(combine, ":")) {
        strcpy(zResource, combine);
    } else {
        char* result = NULL;
        char buf[MAX_PATH]; ClearMemory(buf, MAX_PATH);
        strcpy(buf, combine);
        result = replaceA(buf, "/", "\\");
        strcpy(combine, result);
        free(result); // warning malloc is being used in replaceA
        MoveMemory(zResource, path, offset);
        MoveMemory(&zResource[offset], &combine[0], strlen(combine));
        strcpy(buf, zResource);
        result = replaceA(buf, "\\.\\", "\\");
        strcpy(zResource, result);
        free(result); // warning malloc is being used in replaceA
    }
    return zResource;
}

WCHAR* EXEpath() {
    static WCHAR zpath[MAX_PATH];
    static long done;
    if (done == 0) {
        ClearMemory(zpath, sizeof(zpath));
        if (GetModuleFileName(0, zpath, strSize(zpath))) {
            long nLen = lstrlen(zpath);
            long nPos = nLen;
            for (long K = 1; K <= nLen; K++) {
                if (_wcsicmp(&zpath[nPos - K], L"\\") != 0) { 
                    zpath[nPos - K] = NULL;
                } else {
                    break;
                }
            }
        }
        done = -1;
    }
    return zpath;
}

WCHAR* EXEresource() {
    static WCHAR zpath[MAX_PATH];
    static long done;
    if (done == 0) {
        ClearMemory(zpath, sizeof(zpath));
        Path_Combine(zpath, EXEpath(), L"Resource\\");
        done = -1;
    }
    return zpath;
}

long PARSECOUNT(IN wstring MainString, IN wstring MatchString) {
    long count = 0;
    size_t pos = 0;
    while((pos = MainString.find(MatchString, pos)) != std::string::npos) {
         ++count; ++pos;
    }
    return count;
}

wstring UCASE$(IN wstring sBuf) {
    return CharUpperW((WCHAR*) sBuf.c_str());
}

wstring RTRIM$(IN wstring sBuf, IN wstring sChar) { // dllexport
    wstring sResult = sBuf;
    LONG_PTR nLength = sBuf.length();
    if (nLength && (sChar.length())) {
        //sChar = sChar.substr(0, 1);
        while (nLength > 0) {
            // if (*sBuf.substr(nLength - 1, 1).c_str() == *sChar.c_str()) {
            // This is the sChar ANY search version
            if (std::wstring::npos != sChar.find(sBuf.substr(nLength - 1, 1))) {
                --nLength;
            } else {
                break;
            }
        }
        sResult = sBuf.substr(0, nLength);
    }
    return sResult;
}

wstring PARSE$(IN wstring sMain, IN wstring sDelim, IN long nIndex) {
    wstring sResult = $NULL;
    long nLength = (long) sDelim.length();
    if (nLength == 0) { sDelim = L","; ++nLength; } // Use comma "," as default delimiter
    sMain = RTRIM$(sMain, sDelim); sMain += sDelim;
    if (sMain.length() && nLength) {
        LONG_PTR prev_pos = 0, pos = 0, nCount = 0;
        while( (pos = sMain.find(sDelim, pos)) != std::wstring::npos ) {
            wstring substring(sMain.substr(prev_pos, pos - prev_pos));
            ++nCount;
            if (nCount == nIndex) { sResult = substring; break; }
            prev_pos = ++pos;
        }
    }
    return sResult;
}

LRESULT List_Add(IN HWND hList, IN WCHAR* zTmp) {
    LRESULT nIndex = 0;
    if (hList) {
       if (lstrlen(zTmp)) { nIndex = SendMessage(hList, LB_ADDSTRING, 0, (LPARAM) zTmp); }
    }
    return nIndex;
}

LRESULT List_SetItemData(IN HWND hList, IN long nItem, IN DWORD nRGB) {
    LRESULT nIndex = 0;
    if (hList) {
        nIndex = SendMessage(hList, LB_SETITEMDATA, nItem, (LPARAM) nRGB);
    }
    return nIndex;
}

void Combo_SelectPlus (IN HWND hCombo, IN long nSelected) {
    if (nSelected < 0) { hCombo = 0; }
    if (hCombo) {
        if (nSelected > 0) { nSelected -= 1; } // Because Combo is zero based.
        SendMessage(hCombo, CB_SETCURSEL, nSelected, 0);
    }
}

WCHAR* Combo_Selected (IN HWND hCombo) {
    static WCHAR szData[MAX_PATH];
    SendMessage(hCombo, CB_GETLBTEXT, SendMessage(hCombo, CB_GETCURSEL, 0, 0), (LPARAM) szData);
    return szData;
}

void List_DeleteAll(IN HWND hList) {
    if (IsWindow(hList)) { SendMessage(hList, LB_RESETCONTENT, 0, 0); }
}

long List_FindString(IN HWND hList, IN WCHAR* zTmp) {
    long nIndex = 0;
    if (IsWindow(hList)) {
        nIndex = (long) SendMessage(hList, LB_FINDSTRING, -1, (LPARAM) zTmp);
        if (nIndex > -1) { ++nIndex; }
    }
    return nIndex;
}

long List_Count(IN HWND hList) {
    long nRet = 0;
    if (IsWindow(hList)) { nRet = (long) SendMessage(hList, LB_GETCOUNT, 0, 0); }
    return nRet;
}

long List_GetCursel(IN HWND hList) {
    long nIndex = 0;
    if (hList) {
       nIndex = (long) SendMessage(hList, LB_GETCURSEL, 0, 0);
       if (nIndex > -1) { ++nIndex; } // Because ListBox is zero based
    }
    return nIndex;
}

WCHAR* List_GetText (IN HWND hList, IN long nItem) {
    static WCHAR szData[MAX_PATH];
    memset(szData, 0, sizeof(WCHAR));
    if (nItem > 0) {
        --nItem; SendMessage(hList, LB_GETTEXT, nItem, (LPARAM) szData);
    }
    return szData;
}

void List_SelectPlus(IN HWND hList, IN long nIndex) {
    if (nIndex < 0) { hList = 0; }
    if (hList) {
        if (nIndex > 0) { --nIndex; } // Because ListBox is zero based
        SendMessage(hList, LB_SETCURSEL, nIndex, 0); 
    }
}

long ListView_GetCurrentLine(IN HWND hCtrl) {
    return ListView_GetNextItem(hCtrl, -1, LVNI_FOCUSED);
}

void ListView_SelectPlus(IN HWND hCtrl, IN long nItem) {
    ListView_SetItemState(hCtrl, nItem, LVIS_FOCUSED | LVIS_SELECTED, 0x000F); // Select that one
    ListView_EnsureVisible(hCtrl, nItem, FALSE);
}

string rtrim$(IN string sBuf, IN string sChar) { 
    string sResult = sBuf;
    long nLength = (long) sBuf.length();
    if (nLength && (sChar.length())) {
        //sChar = sChar.substr(0, 1);
        while (nLength > 0) {
            // if (*sBuf.substr(nLength - 1, 1).c_str() == *sChar.c_str()) {
            // This is the sChar ANY search version
            if (std::string::npos != sChar.find(sBuf.substr(nLength - 1, 1))) {
                --nLength; }
            else {
                break;
            }
        }
        sResult = sBuf.substr(0, nLength);
    }
    return sResult;
}

string ltrim$(IN string sBuf, IN string sChar) {
    string sResult = sBuf;
    LONG_PTR nLength = sBuf.length();
    if (nLength && (sChar.length())) {
        //sChar = sChar.substr(0, 1);
        long K = 0;
        while (K < nLength) {
            // if (*sBuf.substr(K, 1).c_str() == *sChar.c_str()) {
            // This is the sChar ANY search version
            if (std::string::npos != sChar.find(sBuf.substr(K, 1))) {
                ++K; }
            else {
                break;
            }
        }
        sResult = sBuf.substr(K, nLength);
    }
    return sResult;
}

string trim$(IN string sBuf, IN string sChar) {
    return ltrim$(rtrim$(sBuf, sChar), sChar);
}

wstring LEFT$(IN wstring sBuf, IN long nLeft) {
    wstring sResult = $NULL;
    LONG_PTR nLength = max(min((long)sBuf.length(), nLeft), 0);
    if (nLength) {
        sResult = sBuf.substr(0, nLength);
    }
    return sResult;
}

string replaceStr(IN string MainString, IN string MatchString, IN string NewString) {
    size_t pos = 0;
    while((pos = MainString.find(MatchString, pos)) != std::string::npos) {
         MainString.replace(pos, MatchString.length(), NewString);
         pos += NewString.length();
    }
    return MainString;
}

BOOL FileExistA(IN char* szFileSpec) {
    DWORD dwAttr = GetFileAttributesA(szFileSpec);
    return ((dwAttr != INVALID_FILE_ATTRIBUTES) && !(dwAttr & FILE_ATTRIBUTE_DIRECTORY));
}

BOOL FileExist(IN WCHAR* szFileSpec) {
    DWORD dwAttr = GetFileAttributes(szFileSpec);
    return ((dwAttr != INVALID_FILE_ATTRIBUTES) && !(dwAttr & FILE_ATTRIBUTE_DIRECTORY));
}

DWORD FileSize(IN WCHAR* szFileSpec) {
    WIN32_FIND_DATA fd = {0};
    DWORD nRet = 0;
    if (lstrlen(szFileSpec)) {
        HANDLE hFind;
        hFind = FindFirstFile(szFileSpec, &fd);
        if (hFind != INVALID_HANDLE_VALUE) {
            FindClose(hFind);
            nRet = fd.nFileSizeLow;
        }
    }
    return nRet;
}

wstring EXTRACT$(IN long nIndex, IN wstring sMain, IN wstring sSearch) {
    wstring sResult = sMain;
    long nLength = (long) sMain.length();
    long nRet = -1; // Not found
    if (nLength && (sSearch.length())) {
        if (nIndex < 0) {
            nRet = (long) sMain.rfind(sSearch, nLength + nIndex + 1); }
        else {
            nRet = (long) sMain.find(sSearch, nIndex);
        }
    }
    if (nRet > -1) { sResult = LEFT$(sMain, nRet); }
    return sResult;
}

void myDoEvents(IN HWND hWnd) {
    MSG msg = { 0 };
    if (hWnd == 0) { hWnd = GetActiveWindow(); }
    while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE)) {
        if (IsDialogMessage(hWnd, &msg) == FALSE) {
            TranslateMessage(&msg);
            DispatchMessage(&msg);
        }
    }
}

//long dpi(IN long nPix) {
//    static float ratio;
//    if (ratio == 0) {
//        HDC hDC = GetDC(NULL); 
//        ratio = (GetDeviceCaps(hDC, LOGPIXELSX) / 96.0f);
//        ReleaseDC(NULL, hDC);
//    }
//    return (long) (nPix * ratio);
//}

WCHAR* Year() {
    time_t     now = time(0);
    struct tm  tstruct;
    static WCHAR buf[5];
    if (localtime_s(&tstruct, &now) == 0) {;
        wcsftime(buf, strSize(buf), L"%Y", &tstruct);
    }
    return buf;
}

//long INSTR(IN long nIndex, IN wstring sMain, IN wstring sSearch) {
//    long nRet = -1; // Not found
//    long nLength = (long) (sMain.length());
//    if (nLength && (sSearch.length())) {
//        if (nIndex < 0) {
//            nRet = (long) (sMain.rfind(sSearch, nLength + nIndex + 1)); }
//        else {
//            nRet = (long) (sMain.find(sSearch, nIndex));
//        }
//    }
//    return nRet + 1;
//}
WCHAR* tcsstr(WCHAR* String, WCHAR* Pattern) {
    int   mi = -1;
    while(Pattern[++mi]) {
        if(String[mi] == 0) return 0;
        if(String[mi] != Pattern[mi]) {
            String++;
            mi = -1;
        }
    }
    return String;
}

void reverse(WCHAR str[], long length) {
    int start = 0;
    int end = length -1;
    while (start < end) {
        swap(*(str + start), *(str + end));
        start++;
        end--;
    }
}

long INWSTR(IN long nIndex, IN WCHAR* MainStr, IN WCHAR* Search) {
    long nRet = -1;
    long nLength = lstrlen(MainStr);
    if (nLength && (lstrlen(Search))) {
        WCHAR* pdest;
        if (nIndex > -1) {
            pdest = tcsstr(&MainStr[nIndex], Search);
            if (pdest) { nRet = long(pdest - &MainStr[0]); }
        } else {
            nIndex += 1; if (nIndex < 0) { nIndex *= -1; }
            reverse(MainStr, nLength);
            pdest= tcsstr(&MainStr[nIndex], Search);
            if (pdest) { nRet = nLength - long(pdest - &MainStr[0]) - 1; }
            reverse(MainStr, nLength);
        }
    }
    return nRet + 1;
}

//wstring MID$(IN wstring sBuf, IN long nStart, IN long nMid = 0) {
//    wstring sResult = $NULL;
//    long nLength = (long) sBuf.length();
//    if (nMid == 0) { nMid = max(nLength - nStart + 1, 0); }
//    if ((nLength > 0) && (nMid > 0)) { sResult = sBuf.substr(nStart - 1, nMid); }
//    return sResult;
//}

// GDIPLUS section
const int UnitPixel = 2;
const int InterpolationModeHighQualityBicubic = 7;
const int InterpolationModeHighQuality = 2;

#define PixelFormat24bppRGB  137224
#define PixelFormat32bppARGB  2498570

enum QualityMode {
    QualityModeInvalid   = -1,
    QualityModeDefault   = 0,
    QualityModeLow       = 1, // Best performance
    QualityModeHigh      = 2  // Best rendering quality
};

enum SmoothingMode {
    SmoothingModeInvalid     = QualityModeInvalid,
    SmoothingModeDefault     = QualityModeDefault,
    SmoothingModeHighSpeed   = QualityModeLow,
    SmoothingModeHighQuality = QualityModeHigh,
    SmoothingModeNone,
    SmoothingModeAntiAlias,
#if (GDIPVER >= 0x0110)
    SmoothingModeAntiAlias8x4 = SmoothingModeAntiAlias,
    SmoothingModeAntiAlias8x8
#endif //(GDIPVER >= 0x0110) 
};

HMODULE gdiplib() {
    static HMODULE hGdip;
    if (hGdip == 0) { hGdip = LoadLibrary(L"GDIPLUS"); }
    return hGdip;
}

long GdipCreateBitmapFromScan0(IN long nWidth, IN long nHeight, IN long nStride, IN long PixelFormat, IN BYTE *lpvBits, OUT LONG_PTR &lpImg) {
    long nRet = -1; // Error
    lpImg = 0;
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (long, long, long, long, BYTE*, LONG_PTR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipCreateBitmapFromScan0"); }
        if (hProc) { nRet = hProc(nWidth, nHeight, nStride, PixelFormat, lpvBits, &lpImg); }
    }
    return nRet;
}

long GdipImageRotateFlip(IN LONG_PTR Img, IN long nOrientation) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (LONG_PTR, long);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipImageRotateFlip"); }
        if (hProc) { nRet = hProc(Img, nOrientation); }
    }
    return nRet;
}

long GdipCreateHBITMAPFromBitmap(IN LONG_PTR Img, OUT HBITMAP &hBitmap, IN long ARGB) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (LONG_PTR, HBITMAP*, long);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipCreateHBITMAPFromBitmap"); }
        if (hProc) { nRet = hProc(Img, &hBitmap, ARGB); }
    }
    return nRet;
}

long GdipDisposeImage(IN LONG_PTR lpImg) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (LONG_PTR);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipDisposeImage"); }
        if (hProc) { nRet = hProc(lpImg); }
    }
    return nRet;
}

long GdipLoadImageFromFile (IN wstring sImgName, OUT LONG_PTR &lpImg) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    lpImg = 0;
    if (hModule) {
        //WCHAR* wc = (WCHAR*)sImgName.c_str();
        long_proc (WCHAR*, LONG_PTR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipLoadImageFromFile"); }
        if (hProc) { 
            nRet = hProc((WCHAR*)sImgName.c_str(), &lpImg); 
        }
    }
    return nRet;
}

long GdipGetImageWidth(IN LONG_PTR lpImg, OUT long &imgW) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    imgW = 0;
    if (hModule) {
        long_proc (LONG_PTR, long*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipGetImageWidth"); }
        if (hProc) { nRet = hProc(lpImg, &imgW); }
    }
    return nRet;
}

long GdipGetImageHeight(IN LONG_PTR lpImg, OUT long &imgH) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    imgH = 0;
    if (hModule) {
        long_proc (LONG_PTR, long*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipGetImageHeight"); }
        if (hProc) { nRet = hProc(lpImg, &imgH); }
    }
    return nRet;
}

void GetImageSize(IN LONG_PTR lpImg, OUT long &imgW, OUT long &imgH) {
    GdipGetImageWidth(lpImg, imgW);
    GdipGetImageHeight(lpImg, imgH);
}

long GdipCreateFromHDC(IN HDC hDC, OUT LONG_PTR &graphics) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    graphics = 0;
    if (hModule) {
        long_proc (HDC, LONG_PTR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipCreateFromHDC"); }
        if (hProc) { nRet = hProc(hDC, &graphics); }
    }
    return nRet;
}

long GdipSetInterpolationMode(IN LONG_PTR graphics, IN long interpolation) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (LONG_PTR, long);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipSetInterpolationMode"); }
        if (hProc) { nRet = hProc(graphics, interpolation); }
    }
    return nRet;
}

long GdipBitmapGetPixel(IN LONG_PTR lpImg, IN long x, IN long y, OUT long &ARGB) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    ARGB = 0;
    if (hModule) {
        long_proc (LONG_PTR, long, long, long*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipBitmapGetPixel"); }
        if (hProc) { nRet = hProc(lpImg, x, y, &ARGB); }
    }
    return nRet;
}

//long GdipDrawImageRectRectI(IN LONG_PTR graphics, IN LONG_PTR lpImg, IN long dstX, IN long dstY, IN long dstW, IN long dstH, IN long srcX, IN long srcY, IN long srcW, IN long srcH, IN long srcUnit, IN LONG_PTR imageattr, IN LONG_PTR lpCallback, IN LONG_PTR callbackdata) {
//    long nRet = -1; // Error
//    HMODULE hModule = gdiplib();
//    if (hModule) {
//        long_proc (LONG_PTR, LONG_PTR, long, long, long, long, long, long, long, long, long, LONG_PTR, LONG_PTR, LONG_PTR);
//        static zProc hProc;
//        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipDrawImageRectRectI"); }
//        if (hProc) { nRet = hProc(graphics, lpImg, dstX, dstY, dstW, dstH, srcX, srcY, srcW, srcH, srcUnit, imageattr, lpCallback, callbackdata); }
//    }
//    return nRet;
//}

long GdipDrawImageRectRectI(IN LONG_PTR graphics, IN LONG_PTR lpImg, IN long dstX, IN long dstY, IN long dstW, IN long dstH, IN long srcX, IN long srcY, IN long srcW, IN long srcH, IN long srcUnit, IN LONG_PTR imageattr, IN LONG_PTR lpCallback, IN LONG_PTR callbackdata) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (LONG_PTR, LONG_PTR, long, long, long, long, long, long, long, long, long, LONG_PTR, LONG_PTR, LONG_PTR);
        zProc hProc = (zProc) GetProcAddress(hModule, "GdipDrawImageRectRectI");
        if (hProc) { nRet = hProc(graphics, lpImg, dstX, dstY, dstW, dstH, srcX, srcY, srcW, srcH, srcUnit, imageattr, lpCallback, callbackdata); }
    }
    return nRet;
}

long GdipDeleteGraphics(IN LONG_PTR graphics) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (LONG_PTR);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipDeleteGraphics"); }
        if (hProc) { nRet = hProc(graphics); }
    }
    return nRet;
}

long GdipDrawImageRectI(IN LONG_PTR graphics, IN LONG_PTR lpImg, IN long x, IN long y, IN long W, IN long H) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (LONG_PTR, LONG_PTR, long, long, long, long);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipDrawImageRectI"); }
        if (hProc) { nRet = hProc(graphics, lpImg, x, y, W, H); }
    }
    return nRet;
}

//long GdipSetCompositingQuality(IN LONG_PTR graphics, IN long CompositingQuality) {
//    long nRet = -1; // Error
//    HMODULE hModule = gdiplib();
//    if (hModule) {
//        long_proc (LONG_PTR, long);
//        static zProc hProc;
//        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipSetCompositingQuality"); }
//        if (hProc) { nRet = hProc(graphics, CompositingQuality); }
//    }
//    return nRet;
//}

long GdipSetSmoothingMode(IN LONG_PTR graphics, IN long SmoothingMode) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (LONG_PTR, long);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipSetSmoothingMode"); }
        if (hProc) { nRet = hProc(graphics, SmoothingMode); }
    }
    return nRet;
}

long GdipCreatePen1(long ARGB, IN float size, IN long unit, OUT LONG_PTR &pen) {
    long nRet = -1; // Error
    pen = 0;
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (long, float, long, LONG_PTR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipCreatePen1"); }
        if (hProc) { nRet = hProc(ARGB, size, unit, &pen); }
    }
    return nRet;
}

long GdipDrawPolygonI(IN LONG_PTR graphics, IN LONG_PTR pen, IN POINT &pt, IN long nCount) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (LONG_PTR, LONG_PTR, POINT*, long);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipDrawPolygonI"); }
        if (hProc) { nRet = hProc(graphics, pen, &pt, nCount); }
    }
    return nRet;
}

long GdipCreateSolidFill(IN long ARGB, OUT LONG_PTR &gdipBrush) {
    long nRet = -1; // Error
    gdipBrush = 0;
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (long, LONG_PTR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipCreateSolidFill"); }
        if (hProc) { nRet = hProc(ARGB, &gdipBrush); }
    }
    return nRet;
}

long GdipFillPolygon2I(IN LONG_PTR graphics, IN LONG_PTR brush, IN POINT &pt, IN long nCount) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (LONG_PTR, LONG_PTR, POINT*, long);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipFillPolygon2I"); }
        if (hProc) { nRet = hProc(graphics, brush, &pt, nCount); }
    }
    return nRet;
}

long GdipDeleteBrush(IN LONG_PTR gdipBrush) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (LONG_PTR);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipDeleteBrush"); }
        if (hProc) { nRet = hProc(gdipBrush); }
    }
    return nRet;
}

long GdipDeletePen(IN LONG_PTR pen) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (LONG_PTR);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipDeletePen"); }
        if (hProc) { nRet = hProc(pen); }
    }
    return nRet;
}

long GdipFillRectangleI(IN LONG_PTR graphics, IN LONG_PTR gdipBrush, IN long x, IN long y, IN long xW, IN long yH) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (LONG_PTR, LONG_PTR, long, long, long, long);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipFillRectangleI"); }
        if (hProc) { nRet = hProc(graphics, gdipBrush, x, y, xW, yH); }
    }
    return nRet;
}

long GdipSetImageAttributesRemapTable(IN LONG_PTR imageattr, IN long ClrAdjType, IN long enableFlag, IN long mapSize, OUT COLORMAP &map) {
    long nRet = -1; // Error
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (LONG_PTR, long, long, long, COLORMAP*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipSetImageAttributesRemapTable"); }
        if (hProc) { nRet = hProc(imageattr, ClrAdjType, enableFlag, mapSize, &map); }
    }
    return nRet;
}

long GdipCreateImageAttributes(OUT LONG_PTR &imageattr) {
    long nRet = -1; // Error
    imageattr = 0;
    HMODULE hModule = gdiplib();
    if (hModule) {
        long_proc (LONG_PTR*);
        static zProc hProc;
        if (hProc == 0) { hProc = (zProc) GetProcAddress(hModule, "GdipCreateImageAttributes"); }
        if (hProc) { nRet = hProc(&imageattr); }
    }
    return nRet;
}

WCHAR* wcscopy (IN WCHAR* dst, IN const WCHAR* src) {
    // Warning, there is no check for buffer overflow !
    long nLen = lstrlen(src);
    //for (long K = 0; K < nLen; K++) {
    //    dst[K] = src[K];
    //}
    MoveMemory(dst, src, nLen * sizeof(WCHAR));
    dst[nLen] = L'\0';
    return dst;
}

// Warning malloc is being used, don't forget to use free!
WCHAR* replace(IN const WCHAR* s, IN const WCHAR* oldW, IN const WCHAR* newW) {
    WCHAR* result;
    long K = 0, cnt = 0, newWlen = lstrlen(newW), oldWlen = lstrlen(oldW);
 
    // Counting the number of times old word occur in the string
    for (K = 0; s[K] != L'\0'; K++) {
        if (wcsstr(&s[K], oldW) == &s[K]) {
            cnt++;
            // Jumping to index after the old word.
            K += oldWlen - 1;
        }
    }
 
    // Making new string of enough length
    long nLen = (K + cnt * (newWlen - oldWlen) + 1) * sizeof(WCHAR);
    result = (WCHAR*) malloc(nLen);
 
    K = 0;
    while (*s) {
        // compare the substring with the result
        if (wcsstr(s, oldW) == s) {
            wcscopy(&result[K], newW);
            K += newWlen;
            s += oldWlen;
        } else {
            result[K++] = *s++;
        }
    }
    result[K] = L'\0';
    return result;
}

// MLL 11-22-2018: might come in handy at some point, n'est-ce pas?
WCHAR* cswconv(IN char* src) { // C string to WCHAR
    static WCHAR dst[4097]; // zero terminated
    mbstowcs(dst, src, 4096);
    return dst;
}

// MLL 12-25-2018: complements the above
CHAR* wcsconv(IN wchar_t* src) { // WCHAR to C string
    static CHAR dst[4097]; // zero terminated
    wcstombs(dst, src, 4096);
    return dst;
}

HMODULE MSVCRT() {
    static HMODULE hModule;
    if (hModule == 0) { hModule = LoadLibrary(L"MSVCRT"); }
    return hModule;
}

long Add_Str(OUT WCHAR* dest, IN WCHAR* srce) {
    long nRet = -1; // Error
    HMODULE hModule =  MSVCRT();
    if (hModule) {
        long_proc_c (WCHAR*, WCHAR*, size_t);
        zProc hProc = (zProc)GetProcAddress(hModule, "wcsncat");
        if (hProc) { nRet = hProc(dest, srce, _TRUNCATE); }
    }
    return nRet;
}

void wsplitpath(IN WCHAR* FullPath, OUT WCHAR* Drive, OUT WCHAR* Dir, OUT WCHAR* FileName, OUT WCHAR* Ext) {
    HMODULE hModule = MSVCRT();
    if (hModule) {
        void_proc_c(WCHAR*, WCHAR*, WCHAR*, WCHAR*, WCHAR*);
        zProc hProc = (zProc)GetProcAddress(hModule, "_wsplitpath");
        if (hProc) { hProc(FullPath, Drive, Dir, FileName, Ext); }
    }
}

HDC DisplayDC() {
    return CreateICA("DISPLAY", NULL, NULL, NULL);
}

//long IsFileImage(IN WCHAR* zFileName) {
//    //long nRet = 0;
//    //WCHAR drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
//    //if (zFileName) {
//    //    wsplitpath(zFileName, drive, dir, fname, ext);
//    //    if (lstrlen(ext)) {
//    //        Add_Str(ext, (WCHAR*)$DOT);
//    //        CharLower(ext);
//    //        if (wcsstr(L".bmp.dib.gif.ico.jpg.jpeg.png.tif.tiff.", ext)) { nRet = -1; }
//    //    }
//    //}
//    //return nRet;
//    long nRet = 0;
//    WCHAR drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT + 1];
//    if (zFileName) {
//        wsplitpath(zFileName, drive, dir, fname, ext);
//        if (lstrlen(ext)) {
//            Add_Str(ext, (WCHAR*)$DOT);
//            CharLower(ext);
//            if (wcsstr(L".tga.", ext)) { return MEDIA_TGA; }
//            if (wcsstr(L".dds.", ext)) { return MEDIA_DDS; }
//            if (wcsstr(L".bmp.dib.gif.ico.jpg.jpeg.png.tif.tiff.", ext)) { nRet = MEDIA_IMG; }
//        }
//    }
//    return nRet;
//}

long TextureCheckExtension(IN WCHAR* zFileName) {
    //long nRet = 0;
    //WCHAR drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT + 1];
    //if (zFileName) {
    //    wsplitpath(zFileName, drive, dir, fname, ext);
    //    if (lstrlen(ext)) {
    //        Add_Str(ext, (WCHAR*)$DOT);
    //        CharLower(ext);
    //        if (wcsstr(L".tga.", ext)) { return MEDIA_TGA; }
    //        if (wcsstr(L".dds.", ext)) { return MEDIA_DDS; }
    //        if (wcsstr(L".bmp.dib.gif.ico.jpg.jpeg.png.tif.tiff.", ext)) { nRet = MEDIA_IMG; }
    //    }
    //}
    //return nRet;
    return ZI_IsFileImage(zFileName);
}

void PutFocusOn(IN HWND nObjectHandle, IN LPARAM lParam = 0) {
    PostMessage(nObjectHandle, WM_LBUTTONDOWN, 0, lParam);
    PostMessage(nObjectHandle, WM_LBUTTONUP, 0, lParam);
}

void WindowRedraw (IN HWND hWnd) {
    RedrawWindow(hWnd, NULL, NULL, RDW_ERASE | RDW_INVALIDATE | RDW_ERASENOW | RDW_UPDATENOW | RDW_ALLCHILDREN | RDW_FRAME);
}

//#define BitMask(BitPos) (1 << (BitPos % 32))
//#define UsingLongArray(ArrayName) ((LONG_PTR*) &ArrayName[0])
//
//void BitSet(IN LONG_PTR *data, IN long BitPos) {
//    data[BitPos / 32] |= (long) BitMask(BitPos);
//}
//
//long BitGet(IN LONG_PTR *data, IN long BitPos) {
//    if ( data[BitPos / 32] & (long) BitMask(BitPos) ) { return 1; } else { return 0; };
//}
//
//void BitArray() { 
//
//        // DIM C(524287) AS LONG ' 524287 * 8 bits = room for 16777216 colors
//        long* C = new long[524287];
//        memset(C, 0, 524287);
//        hDibDC = CreateCompatibleDC(ZI_GetDC(hWnd));
//        hDib = zCreateDIBSection(hDibDC, bmW, bmH, 32);
//        
//        SelectObject(hDibDC, hDib);
//        BitBlt(hDibDC, 0, 0, bmW, bmH, ZI_GetDC(hWnd), 0, 0, SRCCOPY);
//        BITMAP bm;
//        GetObject(hDib, sizeof(bm), &bm);
//        BYTE* pBits = (BYTE*) bm.bmBits;
//        long P, Colr;
//        for (P = 0; P < (bmW * bmH); ++P) {
//             Colr = RGB(pBits[2], pBits[1], pBits[0]);
//             if (BitGet(UsingLongArray(C), Colr) == 0) { 
//                BitSet(UsingLongArray(C), Colr);
//                ++nColorCount;
//             }
//             pBits += 4;
//        }
//        delete [] C;
//    }
//    return nColorCount;
//}

#ifndef TmpStrSize
#define TmpStrSize 4096
#endif

//bugcheck
WCHAR* AllocTmpStr (size_t Bites, size_t iPad, int iAlloc) {
    static int StrCnt;
    static WCHAR *StrFunc[TmpStrSize];
    StrCnt = (StrCnt + 1) & (TmpStrSize - 1);
    if(StrFunc[StrCnt]) {
        free (StrFunc[StrCnt]);
        StrFunc[StrCnt] = NULL;
    }
    if(iAlloc) StrFunc[StrCnt] = (WCHAR*)calloc(Bites + iPad + 1, sizeof(WCHAR));
    return StrFunc[StrCnt];
}

long find_wchar(IN WCHAR* sChar, IN WCHAR* sItem) {
    long nRet = -1;
    long K = 0, nLen = lstrlen(sChar);
    for (K = 0; K < nLen; K++) {
        if (sChar[K] == sItem[0]) { nRet = K; }
    }
    return nRet;
}

WCHAR* RTRIM(IN WCHAR* sBuf, IN WCHAR* sChar) {
    long nLength = lstrlen(sBuf);
    long nLenCount = 0, nLen = lstrlen(sChar);
    if ((nLength) && (nLen)) {
        while (nLength > 0) {
            nLength -= 1;
            if (find_wchar(sChar, &sBuf[nLength]) > -1) {
                sBuf[nLength] = L'\0';
                nLenCount++; if (nLenCount == nLen) { break; }
            } else {
                break;
            }
        }
    }
    return sBuf;
}

void RemoveQuote(IN WCHAR* szName) {
    long nSize = lstrlen(szName);
    if (nSize > 1) {
        if (szName[0] == 34) {
            WCHAR* szBuffer = new WCHAR[nSize];
            ClearMemory(szBuffer, nSize * sizeof(WCHAR));
            MoveMemory(szBuffer, szName + 1, (nSize - 2) * sizeof(WCHAR));
            ClearMemory(szName, nSize * sizeof(WCHAR));
            //MoveMemory(szName, szBuffer, nSize * sizeof(WCHAR));
            MoveMemory(szName, szBuffer, (nSize - 2) * sizeof(WCHAR));
            delete [] szBuffer;
        }
        if (szName[nSize - 1] == 34) { szName[nSize - 1] = L'\0'; }
    }
}

BOOL IsFileObj(IN WCHAR* zFileName) {
    WCHAR drive[_MAX_DRIVE], dir[_MAX_DIR], fname[_MAX_FNAME], ext[_MAX_EXT];
    if (zFileName) {
        RemoveQuote(zFileName);
        wsplitpath(zFileName, drive, dir, fname, ext);
        if (lstrlen(ext)) {
            Add_Str(ext, (WCHAR*)$DOT);
            CharLower(ext);
            if (wcsstr(L".obj.mtl.", ext))
                return TRUE;
        }
    }
    return FALSE;
}

long ParseCount(IN WCHAR* sMain, IN WCHAR* sD) {
    long nCount = 0;
    WCHAR sDelim[MAX_PATH] = {0};
    wcscopy(sDelim, sD);
    long nLength = lstrlen(sDelim);
    if (nLength == 0) { sDelim[0] = ','; sDelim[1] = '\0'; ++nLength; } // Use comma "," as default delimiter
    sMain = RTRIM(sMain, sDelim); Add_Str(sMain, sDelim);
    if (lstrlen(sMain)) {
        long s1 = 0;
        long s2 = INWSTR(s1, sMain, sDelim);
        while(s2) {
            nCount++;
            s1 = s2; s2 = INWSTR(s1, sMain, sDelim);
        }
    }
    return nCount;
}

WCHAR* MID(IN WCHAR* MainStr, IN long nMid, IN long nLen = 0) {
    static WCHAR sMid[TmpStrSize];
    ClearMemory(sMid, sizeof(sMid));
    long nLength = lstrlen(MainStr);
    if (nLen == 0) {
        nLen = max(nLength - nMid + 1, 0);
    }
    nLen += nMid - 1;
    nMid = min(nLength, nMid); nMid = min(nMid, TmpStrSize); nMid = max(nMid, 1);
    long Kmid = 0;
    for (long K = nMid - 1; K < nLen; K++) {
        sMid[Kmid] = MainStr[K];
        Kmid++;
    }
    return sMid;
}

//bugcheck
WCHAR* PARSE(IN WCHAR* sMain, IN WCHAR* sD, IN long nIndex) {
    WCHAR* sTmpStr = AllocTmpStr(lstrlen(sMain), 1, 1);
    if (!sTmpStr) return NULL;

    WCHAR sDelim[MAX_PATH] = {0};
    wcscopy(sDelim, sD);
    long nLength = lstrlen(sDelim);
    if (nLength == 0) { sDelim[0] = ','; sDelim[1] = '\0'; ++nLength; } // Use comma "," as default delimiter
    sMain = RTRIM(sMain, sDelim); Add_Str(sMain, sDelim);
    if (lstrlen(sMain)) {
        long nCount = 0;
        long s1 = 0;
        long s2 = INWSTR(s1, sMain, sDelim);
        while(s2) {
            nCount++;
            if (nCount == nIndex) {
                wcscopy(sTmpStr, MID(sMain, s1 + 1, s2 - s1 - 1));
                break;
            }
            s1 = s2; s2 = INWSTR(s1, sMain, sDelim);
        }
    }
    return sTmpStr;
}

WCHAR* TipFormat(IN WCHAR* szLabel) {
    static WCHAR zTip[128]; // [70]; // MLL 11-22-2018: info tip support
    ClearMemory(zTip, sizeof(zTip));
    if (lstrlen(szLabel)) {
        wcscopy(zTip, L"  ");
        Add_Str(zTip, szLabel);
        Add_Str(zTip, L"  \0");
    }
    return zTip;
}

void SetSwitch(IN long nID, IN long OnOff) {
    long UseFrame = 2;
    if (OnOff) { UseFrame = 1; }
    ZD_SetObjectFrameToUse(nID, UseFrame, TRUE);
}

//#define BitMask(BitPos) (1 << (BitPos % 32))
//#define UsingLongArray(ArrayName) ((LONG_PTR*) &ArrayName[0])
//LONG     gWMBit[32];
//
//void BitSet(IN LONG_PTR *data, IN long BitPos) {
//    data[BitPos / 32] |= (long) BitMask(BitPos);
//    //data[BitPos >> 5] |= BitMask(BitPos); // Based on Charles Tip.
//}
//
//long BitGet(IN LONG_PTR *data, IN long BitPos) {
//    if ( data[BitPos / 32] & (long) BitMask(BitPos) ) { return 1; } else { return 0; };
//    // Based on Charles Tip.
//    //if ( data[BitPos >> 5] & BitMask(BitPos) ) { return 1; } else { return 0; }
//}


BOOL EnableShowDragging(BOOL* activate) {
    BOOL bRet = (FALSE != *activate);
    SystemParametersInfo(SPI_GETDRAGFULLWINDOWS, 0, activate, 0);
    bRet = SystemParametersInfo(SPI_SETDRAGFULLWINDOWS, bRet, 0, 0);
    return bRet;
}

__int64 QuadVAL(IN wstring sNum) {
    WCHAR* EndPtr = NULL;
    __int64 nRet = 0;
    nRet = _wcstoi64(sNum.c_str(), &EndPtr,10);
    return nRet;
}

WCHAR* LEFT(IN WCHAR* MainStr, IN long nLeft) {
    static WCHAR sLeft[MAX_PATH];
    ClearMemory(sLeft, sizeof(sLeft));
    long nLength = lstrlen(MainStr);
    nLeft = min(nLength, nLeft); nLeft = min(nLeft, MAX_PATH);
    for (long K = 0; K < nLeft; K++) {
        sLeft[K] = MainStr[K];
    }
    return sLeft;
}

WCHAR* RIGHT(IN WCHAR* MainStr, IN long nRight) {
    static WCHAR sRight[MAX_PATH];
    ClearMemory(sRight, sizeof(sRight));
    long nLength = lstrlen(MainStr);
    nRight = min(nLength, nRight); nRight = min(nRight, MAX_PATH);
    for (long K = 0; K < nRight; K++) {
        sRight[K] = MainStr[nLength - nRight + K];
    }
    return sRight;
}

long LongVAL(IN WCHAR* sNum) {
    return _wtol(sNum);
}

WCHAR* STRPTR$(IN LONG_PTR N) {
    static WCHAR longstr[33] = {0};
    _i64tow_s(N, longstr, 33, 10);
    return (WCHAR*) longstr;
}

long roundL(IN float number) {
    return long(number + 0.5f);
}

WCHAR* NAMEX(IN WCHAR* sBuf) {
    static WCHAR zname[MAX_PATH];
    ClearMemory(zname, sizeof(zname));
    long n = INWSTR(-1, sBuf, (WCHAR*) $ANTI);
    if (n) {
        wcscopy(zname, MID(sBuf, n + 1));
    } else {
        wcscopy(zname, sBuf);
    }
    return zname;
}

HDC zDisplayDC() {
    return CreateICW(L"DISPLAY", NULL, NULL, NULL);
}

LONG_PTR zCreateAlphaMask (IN WCHAR* zInputName, IN WCHAR* zInputMask, IN BOOL ReturnBitmap) {
    LONG_PTR nResult = 0;
    LONG_PTR img1 = 0, img2 = 0, graphics1 = 0;
    LONG_PTR graphics2 = 0, imgAttr = 0, lpCallback = 0, callbackdata = 0;
    long imgW1 = 0, imgH1 = 0, imgW2 = 0, imgH2 = 0;
    long S1 = INWSTR(-1, zInputName, (WCHAR*) $DOT);
    if (!FileExist(zInputName)) S1 = 0;
    if (S1) {
        // Make sure that a full path is being used.
        zCheckName(zInputMask);
        long S2 = INWSTR(-1, zInputMask, (WCHAR*) $DOT);
        if (!FileExist(zInputMask)) S2 = 0;
        if (S2 == 0) S1 = 0;
    }
    if (S1) {
        long ImageType = ZI_IsFileImage(zInputMask);
        long nRet = -1, nSwapRB = -1;
        if (ImageType == MEDIA_TGA) {
            nRet = ZI_LoadTGA(zInputMask, &img2);
        } else if (ImageType == MEDIA_DDS) {
            nRet = ZI_LoadDDS(zInputMask, &img2, &nSwapRB);
        } else { // all GDI+
            nRet = GdipLoadImageFromFile(zInputMask, img2);
        }
        if (nRet == 0) {
            GetImageSize(img2, imgW2, imgH2);
            nRet = -1, nSwapRB = -1;
            ImageType = ZI_IsFileImage(zInputName);
            if (ImageType == MEDIA_TGA) {
                nRet = ZI_LoadTGA(zInputName, &img1);
            } else if (ImageType == MEDIA_DDS) {
                nRet = ZI_LoadDDS(zInputName, &img1, &nSwapRB);
            } else { // all GDI+
                nRet = GdipLoadImageFromFile(zInputName, img1);
            }
            if (nRet == 0) {
                GetImageSize(img1, imgW1, imgH1);
                //if ((imgW1 == imgW2) && (imgH1 == imgH2)) {
                    HDC hDC = zDisplayDC();
                    HDC ImgHDC = CreateCompatibleDC(hDC);
                    HBITMAP hbmReturn = zCreateDIBSection(hDC, imgW1, imgH1, 32);
                    SelectObject(ImgHDC, hbmReturn);

                    HDC MaskHDC = CreateCompatibleDC(hDC);
                    //HBITMAP hbmMask = zCreateDIBSection(hDC, imgW2, imgH2, 32);
                    HBITMAP hbmMask = zCreateDIBSection(hDC, imgW1, imgH1, 32); // For resize purpose
                    SelectObject(MaskHDC, hbmMask);
                    DeleteDC(hDC);

                    if (GdipCreateFromHDC(MaskHDC, graphics2) == 0) {

                        // Set up stretching QualityMode, and resize the mask on the fly to match the zInputName size
                        GdipSetInterpolationMode(graphics2, 2); // InterpolationModeHighQuality
                        if (GdipDrawImageRectRectI(graphics2, img2, 0, 0, imgW1, imgH1, 0, 0, imgW2, imgH2, 2, imgAttr, lpCallback, callbackdata) == 0) {

                        //if (GdipDrawImageRectI(graphics2, img2, 0, 0, imgW2, imgH2) == 0) {
                            // Draw image
                            if (GdipCreateFromHDC(ImgHDC, graphics1) == 0) {
                                if (GdipDrawImageRectI(graphics1, img1, 0, 0, imgW1, imgH1) == 0) {
                                    long AlphaRGB1 = 0, AlphaRGB2 = 0;
                                    GdipBitmapGetPixel(img2, 0, 0, AlphaRGB2);
                                    BITMAP bm2 = { 0 };
                                    GetObject(hbmMask, sizeof(bm2), &bm2);
                                    BYTE* pBits2 = (BYTE*) bm2.bmBits;

                                    GdipBitmapGetPixel(img1, 0, 0, AlphaRGB1);
                                    BITMAP bm1 = { 0 };
                                    GetObject(hbmReturn, sizeof(bm1), &bm1);
                                    BYTE* pBits1 = (BYTE*) bm1.bmBits;
                                    for (long y = 0; y < bm1.bmHeight; ++y) {
                                        for (long x = 0; x < bm1.bmWidth; ++x) {
                                            pBits1[3] = (BYTE) ((pBits2[2] * 0.2989f) + (pBits2[1] * 0.5870f) + (pBits2[0] * 0.114f));
                                            pBits2 += 4;
                                            pBits1 += 4;
                                        }
                                    }
                                }
                                // Cleanup
                                GdipDeleteGraphics(graphics1);
                            }
                            if (img1) { GdipDisposeImage(img1); img1 = 0; }
                            img1 = zBitmapToImage(ImgHDC);
                            if (ImgHDC) DeleteDC(ImgHDC);
                            DeleteObject(hbmReturn);
                        }

                        if (img2) { GdipDisposeImage(img2); img2 = 0; }
                        if (graphics2) GdipDeleteGraphics(graphics2);
                    }
                    if (MaskHDC) DeleteDC(MaskHDC);
                    DeleteObject(hbmMask);
                //}
            }
        }
    }

    if (img1) {
        HDC hDC = zDisplayDC();
        HDC ImgHDC = CreateCompatibleDC(hDC);
        HBITMAP hbmReturn = zCreateDIBSection(hDC, imgW1, imgH1, 32);
        SelectObject(ImgHDC, hbmReturn);
        DeleteDC(hDC);
        // Draw image
        if (GdipCreateFromHDC(ImgHDC, graphics1) == 0) {
            for (long K = 0; K < 4; K++) { // Increase opacity
                GdipDrawImageRectI(graphics1, img1, 0, 0, imgW1, imgH1);
            }
            // Cleanup
            GdipDeleteGraphics(graphics1);
        }
        GdipDisposeImage(img1);
        if (ReturnBitmap) {
            DeleteDC(ImgHDC);
            nResult = (LONG_PTR) hbmReturn;
        } else {
            nResult = zBitmapToImage(ImgHDC);
            DeleteDC(ImgHDC);
            DeleteObject(hbmReturn);
        }
    }
    return nResult;
}

int instr(IN char* str, IN char* search) { // PAT: 01-04-2020
    int nRet = 0;
    char *pdest = strstr(str, search );
    if (pdest != NULL)
        nRet = (int) (pdest - str + 1);
    return nRet;
}
